Getting Started with Pager Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the Pager module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.pager.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-pager id="pager"></smart-pager>

    Host container (id matches appendTo on Smart.Pager):

    <div id="pagerContainer"></div>

  5. Initialize after the module loads: define a const pagerOptions object, then either bind with Smart('#pager', ...) on the semantic tag or use new Smart.Pager({ ...pagerOptions, appendTo: '#pagerContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.pager.js';
    
    	const pagerOptions = { disabled: true };
    
    	// Option A - semantic <smart-pager> with id="pager"
    	Smart('#pager', class {
    		get properties() {
    			return pagerOptions;
    		}
    	});
    
    	// Option B - host div id="pagerContainer"
    	// const pagerInstance = new Smart.Pager({
    	// 	...pagerOptions,
    	// 	appendTo: '#pagerContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myPager = new Smart.Pager('#pager', pagerOptions);
    	// document.body.appendChild(myPager);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Pager('#pager', pagerOptions) with appendChild, and document.createElement('smart-pager') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Pager({ ...options, appendTo: '#...' }); new Smart.Pager('#pager', pagerOptions) plus appendChild on the returned element; and document.createElement('smart-pager') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myPager = new Smart.Pager('#pager', pagerOptions)):

	const pagerOptions = { disabled: true };
	const myPager = new Smart.Pager('#pager', pagerOptions);
	document.body.appendChild(myPager);
	

Create with document.createElement('smart-pager'), assign properties (same as any custom element), then append:

	const pagerOptions = { disabled: true };
	const pager = document.createElement('smart-pager');
	Object.assign(pager, pagerOptions);
	document.body.appendChild(pager);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.pager.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const pagerOptions = { disabled: true };
		const pager = new Smart.Pager({
			...pagerOptions,
			appendTo: '#pagerContainer'
		});
	}
	

Appearance

The total number of items and the number of visualized items are controlled by the following properties :

  • pagesCount - total number of items.
  • pageIndexSelectors - the number of items displayed on page.

The pager can have multiple navigation buttons, controlled by the following properties:

  • showFirstLastNavigationButtons - buttons for navigation to the firs and the last item.
  • showPrevNextNavigationButtons - buttons for navigation to the previous and the next item.
  • autoEllipsis - ellipsis buttons are displayed as indicators and additional help to navigate between pages. Available options are:
    • none - ellipsis are hidden.
    • before - ellipsis are shown as navigation to previous page only.
    • after - ellipsis are shown as navigation to next page only.
    • both - ellipsis are shown as navigation to both previous and next pages.
<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.pager.js"></script>
</head>
<body>
    <smart-pager show-prev-next-navigation-buttons show-first-last-navigation-buttons show-page-index-selectors pages-count="5" page-index-selectors="5" show-summary></smart-pager>
</body>
</html>

Demo

Additional options to control the element are :

  • showSummary - controls the visibility of segment that displays range of visible items.
  • showPageSizeSelector - Determines whether the page size selector is displayed.
  • showNavigationInput - Determines whether the navigation input is displayed.
 <smart-pager show-page-size-selector show-navigation-input show-prev-next-navigation-buttons pages-count="10" show-summary></smart-pager>

Demo

Instead arrows, navigation buttons can have text labels. To achieve this, showNavigationButtonLabels property must be set to true.
An element with shown text labels, could be localized. The user can define the text, wich is shown in for particular language. Setting of messages defines the text values of each button. Locale defines the language used at the moment.

 <smart-pager show-navigation-button-labels locale="fr" show-prev-next-navigation-buttons show-first-last-navigation-buttons how-page-index-selectors pages-count="300" page-index-selectors="10" ></smart-pager>

Demo

Methods

The element offers the following methods:

  • first - Selects first item.
     <script>
         window.onload = function () {
             var pager = document.querySelector('smart-pager');
             pager.first();
         }
     </script>
    
  • last - Selects last item.
     <script>
         window.onload = function () {
             var pager = document.querySelector('smart-pager');
             pager.last();
         }
     </script>
    
  • navigateTo - Navigates to an item with particular index.
     <script>
         window.onload = function () {
             var pager = document.querySelector('smart-pager');
             pager.navigateTo(5);
         }
     </script>
    
  • next - Navigates to the next item(if exists such an item).
     <script>
         window.onload = function () {
             var pager = document.querySelector('smart-pager');
             pager.next();
         }
     </script>
    
  • prev - Navigates to the previous item(if exists such an item).
     <script>
         window.onload = function () {
             var pager = document.querySelector('smart-pager');
             pager.prev();
         }
     </script>
    

Append to the DOM:

const container = document.getElementById('pager-container');
container.appendChild(pager);
	

Remove from the DOM:

pager.remove();
	

Set a property:

pager.disabled = true;
pager.theme = 'dark';
	

Get a property value:

const isDisabled = pager.disabled;
const currentTheme = pager.theme;
	

Invoke a method:

pager.refresh();
pager.focus();
	

Add event listener:

pager.addEventListener('change', (event) => {
    console.log('change triggered:', event.detail);
});
	

Remove event listener:

const handlePagerEvent = (event) => {
    console.log('change triggered:', event.detail);
};

pager.addEventListener('change', handlePagerEvent);
pager.removeEventListener('change', handlePagerEvent);
	

Accessibility

The Pager component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Pager - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/pager/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import PagerModule from smart-webcomponents-angular/pager: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { PagerModule } from 'smart-webcomponents-angular/pager';

4 Root component (standalone)

Add PagerModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { PagerComponent } from 'smart-webcomponents-angular/pager';

import { PagerModule } from 'smart-webcomponents-angular/pager';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ PagerModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('pager', { read: PagerComponent, static: false }) pager!: PagerComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-pager as needed:

 <smart-pager #pager [showPrevNextNavigationButtons]="true" [showFirstLastNavigationButtons]="true"
    [showPageIndexSelectors]="true" [pagesCount]="5" [pageIndexSelectors]="5"></smart-pager>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put PagerModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put PagerModule from smart-webcomponents-angular/pager on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { PagerModule } from 'smart-webcomponents-angular/pager';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, PagerModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The Pager component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Pager Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/pager/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { Pager } from 'smart-webcomponents-react/pager';

const App = () => {
    return (
        <div>
            <Pager
                showPrevNextNavigationButtons
                showFirstLastNavigationButtons
                showPageIndexSelectors
                pagesCount={5}
                pageIndexSelectors={5}
            />
        </div>
    );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Pager, PagerProps } from 'smart-webcomponents-react/pager';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Pager component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.